#include "ili9327_lcd.h"
#include "ascii.h"	
#include "stdlib.h"
//#define DEBUG_DELAY() 
#include "bsp_sdfs_app.h"

#include "stm32f10x.h"
#include <math.h>
#include "stm32f10x_fsmc.h" 

#define COLUMN		240
#define PAGE		400	

// SRT stringд
#define STR_WIDTH		9	/* ַ6 */
#define STR_HEIGHT		12		/* ַ߶12 */



 /**
  * @brief  ʼLcDIO
  * @param  
  * @retval      Լ޸
  */
void LCD_GPIO_Config(void)
{
    GPIO_InitTypeDef GPIO_InitStructure;
    
    /* ʹFSMCʱ*/
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_FSMC, ENABLE);
    
    /* ʹFSMCӦӦܽʱ*/
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOD 
                            | RCC_APB2Periph_GPIOE 
	                          | RCC_APB2Periph_GPIOB,ENABLE);
    
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    
    /* LCDƹܽ*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;		
    GPIO_Init(GPIOB, &GPIO_InitStructure);
    
    /* LCDλƹܽ*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1 ; 	 
    GPIO_Init(GPIOE, &GPIO_InitStructure);  		   
    
    /* FSMCӦ,FSMC-D0~D15: PD 14 15 0 1,PE 7 8 9 10 11 12 13 14 15,PD 8 9 10*/	
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode =  GPIO_Mode_AF_PP;
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_1 | GPIO_Pin_8 | GPIO_Pin_9 | 
                                  GPIO_Pin_10 | GPIO_Pin_14 | GPIO_Pin_15;
    GPIO_Init(GPIOD, &GPIO_InitStructure);
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | 
                                  GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | 
                                  GPIO_Pin_15;
    GPIO_Init(GPIOE, &GPIO_InitStructure); 
    
		/* FSMCӦĿ
		 * PD4-FSMC_NOE   :LCD-RD
		 * PD5-FSMC_NWE   :LCD-WR
		 * PD7-FSMC_NE1   :LCD-CS
		 * PD11-FSMC_A16  :LCD-DC
		*/
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4; 
    GPIO_Init(GPIOD, &GPIO_InitStructure);
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5; 
    GPIO_Init(GPIOD, &GPIO_InitStructure);
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7; 
    GPIO_Init(GPIOD, &GPIO_InitStructure);  
    
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11; 
    GPIO_Init(GPIOD, &GPIO_InitStructure);  
    
    /* tft control gpio init */	 
    /*  */
	//	GPIO_ResetBits(GPIOB, GPIO_Pin_1);  
}


/************************************************************
 * LCD_FSMC_Config
 *   LCD  FSMC ģʽ
 *   
 *   
 *   ڲ        
 ************************************************************/
static void LCD_FSMC_Config(void)
{
    FSMC_NORSRAMInitTypeDef  FSMC_NORSRAMInitStructure;
    FSMC_NORSRAMTimingInitTypeDef  p; 
    
    
    p.FSMC_AddressSetupTime = 0x00;	 //ַʱ
    p.FSMC_AddressHoldTime = 0x00;	 //ַʱ
    p.FSMC_DataSetupTime = 0x02;		 //ݽʱ
    p.FSMC_BusTurnAroundDuration = 0x00;
    p.FSMC_CLKDivision = 0x00;
    p.FSMC_DataLatency = 0x00;
    p.FSMC_AccessMode = FSMC_AccessMode_B;	 // һʹģʽBLCD
    
    FSMC_NORSRAMInitStructure.FSMC_Bank = FSMC_Bank1_NORSRAM1;
    FSMC_NORSRAMInitStructure.FSMC_DataAddressMux = FSMC_DataAddressMux_Disable;
    FSMC_NORSRAMInitStructure.FSMC_MemoryType = FSMC_MemoryType_NOR;
    FSMC_NORSRAMInitStructure.FSMC_MemoryDataWidth = FSMC_MemoryDataWidth_16b;
    FSMC_NORSRAMInitStructure.FSMC_BurstAccessMode = FSMC_BurstAccessMode_Disable;
    FSMC_NORSRAMInitStructure.FSMC_WaitSignalPolarity = FSMC_WaitSignalPolarity_Low;
    FSMC_NORSRAMInitStructure.FSMC_WrapMode = FSMC_WrapMode_Disable;
    FSMC_NORSRAMInitStructure.FSMC_WaitSignalActive = FSMC_WaitSignalActive_BeforeWaitState;
    FSMC_NORSRAMInitStructure.FSMC_WriteOperation = FSMC_WriteOperation_Enable;
    FSMC_NORSRAMInitStructure.FSMC_WaitSignal = FSMC_WaitSignal_Disable;
    FSMC_NORSRAMInitStructure.FSMC_ExtendedMode = FSMC_ExtendedMode_Disable;
    FSMC_NORSRAMInitStructure.FSMC_WriteBurst = FSMC_WriteBurst_Disable;
    FSMC_NORSRAMInitStructure.FSMC_ReadWriteTimingStruct = &p;
    FSMC_NORSRAMInitStructure.FSMC_WriteTimingStruct = &p;     
    FSMC_NORSRAMInit(&FSMC_NORSRAMInitStructure); 
	   
    /* Enable FSMC Bank1_SRAM Bank */
    FSMC_NORSRAMCmd(FSMC_Bank1_NORSRAM1, ENABLE);  
}


/*********************************************************
*	ܣҺλ
*********************************************************/
 void LCD_Rst(void)
{		GPIO_ResetBits(GPIOE, GPIO_Pin_1);	 //͵ƽλ	
 
    delay_ms(1);					   
   GPIO_SetBits(GPIOE, GPIO_Pin_1);
 
    delay_ms(1);
}

/**
 * @brief  lcdʼĴ
 * @param  
 * @retval 
 */
//void LCD_REG_Config(void)
//{
//	/*  Power control B (CFh)  */
//////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xCF);
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x81);
//	LCD_ILI9341_Parameter(0x30);
//	
//	/*  Power on sequence control (EDh) */
//	//DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xED);
//	LCD_ILI9341_Parameter(0x64);
//	LCD_ILI9341_Parameter(0x03);
//	LCD_ILI9341_Parameter(0x12);
//	LCD_ILI9341_Parameter(0x81);
//	
//	/*  Driver timing control A (E8h) */
////	//DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xE8);
//	LCD_ILI9341_Parameter(0x85);
//	LCD_ILI9341_Parameter(0x10);
//	LCD_ILI9341_Parameter(0x78);
//	
//	/*  Power control A (CBh) */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xCB);
//	LCD_ILI9341_Parameter(0x39);
//	LCD_ILI9341_Parameter(0x2C);
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x34);
//	LCD_ILI9341_Parameter(0x02);
//	
//	/* Pump ratio control (F7h) */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xF7);
//	LCD_ILI9341_Parameter(0x20);
//	
//	/* Driver timing control B */
//	//DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xEA);
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x00);
//	
//	/* Frame Rate Control (In Normal Mode/Full Colors) (B1h) */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xB1);
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x1B);
//	
//	/*  Display Function Control (B6h) */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xB6);
//	LCD_ILI9341_Parameter(0x0A);
//	LCD_ILI9341_Parameter(0xA2);
//	
//	/* Power Control 1 (C0h) */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xC0);
//	LCD_ILI9341_Parameter(0x35);
//	
//	/* Power Control 2 (C1h) */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0xC1);
//	LCD_ILI9341_Parameter(0x11);
//	
//	/* VCOM Control 1(C5h) */
//	LCD_ILI9341_CMD(0xC5);
//	LCD_ILI9341_Parameter(0x45);
//	LCD_ILI9341_Parameter(0x45);
//	
//	/*  VCOM Control 2(C7h)  */
//	LCD_ILI9341_CMD(0xC7);
//	LCD_ILI9341_Parameter(0xA2);
//	
//	/* Enable 3G (F2h) */
//	LCD_ILI9341_CMD(0xF2);
//	LCD_ILI9341_Parameter(0x00);
//	
//	/* Gamma Set (26h) */
//	LCD_ILI9341_CMD(0x26);
//	LCD_ILI9341_Parameter(0x01);
////	DEBUG_DELAY();
//	
//	/* Positive Gamma Correction */
//	LCD_ILI9341_CMD(0xE0); //Set Gamma
//	LCD_ILI9341_Parameter(0x0F);
//	LCD_ILI9341_Parameter(0x26);
//	LCD_ILI9341_Parameter(0x24);
//	LCD_ILI9341_Parameter(0x0B);
//	LCD_ILI9341_Parameter(0x0E);
//	LCD_ILI9341_Parameter(0x09);
//	LCD_ILI9341_Parameter(0x54);
//	LCD_ILI9341_Parameter(0xA8);
//	LCD_ILI9341_Parameter(0x46);
//	LCD_ILI9341_Parameter(0x0C);
//	LCD_ILI9341_Parameter(0x17);
//	LCD_ILI9341_Parameter(0x09);
//	LCD_ILI9341_Parameter(0x0F);
//	LCD_ILI9341_Parameter(0x07);
//	LCD_ILI9341_Parameter(0x00);
//	
//	/* Negative Gamma Correction (E1h) */
//	LCD_ILI9341_CMD(0XE1); //Set Gamma
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x19);
//	LCD_ILI9341_Parameter(0x1B);
//	LCD_ILI9341_Parameter(0x04);
//	LCD_ILI9341_Parameter(0x10);
//	LCD_ILI9341_Parameter(0x07);
//	LCD_ILI9341_Parameter(0x2A);
//	LCD_ILI9341_Parameter(0x47);
//	LCD_ILI9341_Parameter(0x39);
//	LCD_ILI9341_Parameter(0x03);
//	LCD_ILI9341_Parameter(0x06);
//	LCD_ILI9341_Parameter(0x06);
//	LCD_ILI9341_Parameter(0x30);
//	LCD_ILI9341_Parameter(0x38);
//	LCD_ILI9341_Parameter(0x0F);
//	
//	/* memory access control set */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0x36); 	
//	LCD_ILI9341_Parameter(0xC8);    /*  Ͻǵ()½(յ)ɨ跽ʽ*/
////	DEBUG_DELAY();
//	
//	/* column address control set */
//	LCD_ILI9341_CMD(0X2A); 
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0xEF);
//	
//	/* page address control set */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0X2B); 
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x00);
//	LCD_ILI9341_Parameter(0x01);
//	LCD_ILI9341_Parameter(0x3F);
//	
//	/*  Pixel Format Set (3Ah)  */
////	DEBUG_DELAY();
//	LCD_ILI9341_CMD(0x3a); 
//	LCD_ILI9341_Parameter(0x55);
//	
//	/* Sleep Out (11h)  */
//	LCD_ILI9341_CMD(0x11);	
//	Lcd_Delay(0xAFFf<<2);
////	DEBUG_DELAY();
//	
//	/* Display ON (29h) */
//	LCD_ILI9341_CMD(0x29); 
//}

/**
 * @brief  lcdʼҪõlcdһҪ
 * @param  
 * @retval 
 */
/********************************************************
*	ܣҺд
********************************************************/
static void WriteComm(u16 CMD)
{			
	*(__IO u16 *) (Bank1_LCD_C) = CMD;
}

/*******************************************************
*	ܣҺдݡ
*******************************************************/
static void WriteData(u16 tem_data)
{			
	*(__IO u16 *) (Bank1_LCD_D) = tem_data;
}


/**********************************************
*	ܣҺʼ,аFSMCʼҺ
*		  ʼ
***********************************************/
void 	LCD_Init(void)
{	
	LCD_GPIO_Config();
	LCD_FSMC_Config();//FSMCʼ
	delay_ms(2);
	LCD_Rst();
	
	WriteComm(0x11);  // SLP OUT 
	//delay_ms(1); 
	
	WriteComm(0xF3); //Set EQ 
	WriteData(0x08);    
	WriteData(0x20);    
	WriteData(0x20);    
	WriteData(0x08);    
	
	WriteComm(0xE7);  
	WriteData(0x60);   //OPON 
	
	WriteComm(0xD1);  // Set VCOM 
	WriteData(0x00);    
	WriteData(0x5D);    
	WriteData(0x15);    
	
	WriteComm(0xD0); //Set power related setting 
	WriteData(0x07);    
	WriteData(0x02);   //VGH:15V,VGL:-7.16V (BOE LCD: VGH:12~18V,VGL:-6~10V)  
	WriteData(0x8B);    
	WriteData(0x03);    
	WriteData(0xD4);    
	
	WriteComm(0x3A); // Set_pixel_format
	WriteData(0x55); //0x55:16bit/pixel,65k;0x66:18bit/pixel,262k;

	WriteComm(0x36); //Set_address_mode
	WriteData(0x28);
	
 	WriteComm(0x21); //Enter_invert_mode
	
	WriteComm(0xC1);   //Set Normal/Partial mode display timing  
	WriteData(0x10);    
	WriteData(0x1A);    
	WriteData(0x02);    
	WriteData(0x02);    
	WriteComm(0xD1);
	WriteData(0x00);
	WriteData(0x71);
	WriteData(0x19);
	
	WriteComm(0xD0);
	WriteData(0x07);
	WriteData(0x01);
	WriteData(0x08); 
	WriteComm(0xC0);  //Set display related setting  
	WriteData(0x10);    
	WriteData(0x31);    
	WriteData(0x00);    
	WriteData(0x00);    
	WriteData(0x01);    
	WriteData(0x02);    
	
	WriteComm(0xC4);  //Set waveform timing 
	WriteData(0x01);    
	
	WriteComm(0xC5);  //Set oscillator 
	WriteData(0x04);    //72Hz
	WriteData(0x01); 
	
	WriteComm(0xD2);  //Set power for normal mode 
	WriteData(0x01);    
	WriteData(0x44);    
	
	WriteComm(0xC8); //Set Gamma
	WriteData(0x04);
	WriteData(0x67);
	WriteData(0x35);
	WriteData(0x04);
	WriteData(0x08);
	WriteData(0x06);
	WriteData(0x24);
	WriteData(0x01);
	WriteData(0x37);
	WriteData(0x40);
	WriteData(0x03);
	WriteData(0x10);
	WriteData(0x08);
	WriteData(0x80);
	WriteData(0x00);
	WriteComm(0x2A); 
	WriteData(0x00);
	WriteData(0x00);
	WriteData(0x00);
	WriteData(0xeF);
	WriteComm(0x2B); 
	WriteData(0x00);
	WriteData(0x00);
	WriteData(0x01);
	WriteData(0x8F);  
	
	WriteComm(0xCA);  //Set DGC LUT
	WriteData(0x00);     
   
	WriteComm(0xEA);  //Set DGC
	WriteData(0x80);    
	
	WriteComm(0x29);  // Set_display_on  
//	LCD_delay(1); 

	WriteComm(0x2c);  //Write_memory_start	
	
	LCD_Clear(0,0,400,240,WHITE);
	//Ҫʱˢز٣
  delay_ms(1);
	LCD_Clear(0,0,400,240,WHITE);
	Lcd_Light_ON;

}

/**********************************************************
*	ܣ趨Һʾ
*	XstartʾX᷽Ŀʼ
*		  XendʾX᷽Ľ
*		  YstartʾY᷽Ŀʼ
*		  YendʾY᷽Ľ
**********************************************************/
void BlockWrite(unsigned int Xstart,unsigned int Xend,unsigned int Ystart,unsigned int Yend) 
{
	WriteComm(0x2a);   
	WriteData(Xstart>>8);
	WriteData(Xstart&0xff);
	WriteData(Xend>>8);
	WriteData(Xend&0xff);

	WriteComm(0x2b);   
	WriteData(Ystart>>8);
	WriteData(Ystart&0xff);
	WriteData(Yend>>8);
	WriteData(Yend&0xff);
	
	WriteComm(0x2c);
}

/********************************************************
*	ܣĻָλûص
*	xĻX
*		  yĻY
*		  Colorɫ
********************************************************/
void LCD_SetPoint(u16 x, u16 y, u16 color)
//void DrawPixel(u16 x, u16 y, int Color)
{
	BlockWrite(x,x,y,y);
	*(__IO u16 *) (Bank1_LCD_D) = color;							  
}

/*********************************************
*	ܣȡĻָλõɫ
*	xָλõx
*		  yָλõy
*	ֵָλõɫ
*********************************************/
u16 GetPoint(u16 x,u16 y)
{
	volatile u16 a;	
	WriteComm(0x2a);   
	WriteData(x>>8);
	WriteData(x&0xff);

	WriteComm(0x2b);   
	WriteData(y>>8);
	WriteData(y&0xff);
	a=0;a=0;a=0;a=0;a=0;
	WriteComm(0x2E);
	a=0;a=0;a=0;a=0;a=0;a=0;
	a = *(__IO u16 *) (Bank1_LCD_D);
	a=0;a=0;a=0;a=0;a=0;
	a = *(__IO u16 *) (Bank1_LCD_D);
	return a;
}

/**********************************************
ܣLCDָָɫ

ڲxStart xʼ
          ySrart yֹ
          xLong Ҫѡεx򳤶
          yLong  Ҫѡεy򳤶
		  ColorҪɫ
***********************************************/

void LCD_Clear(uint16_t x, uint16_t y, uint16_t width, uint16_t height, uint16_t color)
{
	uint32_t i = 0;
	Lcd_GramScan(4);
	/* column address control set */
  WriteComm(0X2A);
	WriteData( x >> 8 );	 /* ȸ8λȻ8λ */
	WriteData( x & 0xff );	         /* column start   */ 
	WriteData( (x+width-1) >> 8 );   /* column end   */
	WriteData( (x+width-1) & 0xff );
	
	/* page address control set */	
  WriteComm(0X2B); 			     
	WriteData( y >> 8 );			/* page start   */
	WriteData( y & 0xff );
	WriteData( (y+height-1) >> 8);  /* page end     */
	WriteData( (y+height-1) & 0xff);
	
	/* memory write */
	WriteComm(0x2c);	
		
	for( i=0; i < width*height; i++ )
	{
		//LCD_WR_Data( color );
		*(__IO u16 *) (Bank1_LCD_D) = color;
	}	
}

/**********************************************
ܣLCDָͼƬ

ڲxStart xʼ
          ySrart yֹ
          xLong Ҫѡεx򳤶
          yLong  Ҫѡεy򳤶
		  pic ָͼƬĴ洢
***********************************************/
void Lcd_FillPic(u16 xStart,u16 yStart,u16 xLong,u16 yLong,u16 *pic)
{
	u32 cnt;
	LCD_OpenWindow(xStart,xStart+xLong-1,yStart,yStart+yLong-1);
	for (cnt=xLong*yLong;cnt>0;cnt--)
	{
		*(__IO u16 *) (Bank1_LCD_D) = *(pic++);
	}	
}


/*********************************************************
*	ܣ߶
*	x1,y1߶εһ˵
*		  x2,y2߶εһ˵
*********************************************************/
void LCD_DrawLine(u16 x1,u16 y1,u16 x2,u16 y2,u16 color)
{
//ֱ߷(X-X1)/(X2-X)=(Y-Y1)/(Y2-Y)
//y=(x*y2-x*y1+x2*y1-x1*y2)/(x2-x1)
	s16 temp;
	LCD_SetPoint(x1,y1,color);
	if(x2>x1)
	{
		for(temp=x1+1;temp<x2;temp++)
		LCD_SetPoint(temp,(temp*y2-temp*y1+x2*y1-x1*y2)/(x2-x1),color);
	}
	if(x2<x1)
	{
		for(temp=x2+1;temp<x1;temp++)
			LCD_SetPoint(temp,(temp*y2-temp*y1+x2*y1-x1*y2)/(x2-x1),color);
	}
	if(x2==x1)
	{
		if(y1>y2)
			for(temp=y2+1;temp<y1;temp++)
				LCD_SetPoint(x1,temp,color);
		if(y1<y2)
			for(temp=y1+1;temp<y2;temp++)
				LCD_SetPoint(x1,temp,color);
	}
	LCD_SetPoint(x2,y2,color);	
}

/************************************************************
*	ܣԲ
*	x,yԲ
*		  r Բ뾶
*		  color Բɫ
************************************************************/
void PlotCircle(u16 x,u16 y,u16 r,u16 color)
{
//Բ̣X-a)(X-a)+(Y-b)(Y-b)=r*r
//лԲΪ߲
	u16 temp;
	u16 cnt;
	for(cnt=x-r;cnt<=x+r;cnt++)
	{
		temp=(u16)sqrt(r*r-(cnt-x)*(cnt-x));
		LCD_SetPoint(cnt,y+temp,color);
		LCD_SetPoint(cnt,y-temp,color);
	}
	for(cnt=y-r;cnt<y+r;cnt++)
	{
		temp=(u16)sqrt(r*r-(cnt-y)*(cnt-y));
		 LCD_SetPoint(x+temp,cnt,color);
		 LCD_SetPoint(x-temp,cnt,color);
		//DrawPixel(x+temp,cnt,color);
		//DrawPixel(x-temp,cnt,color);
	}
}
void LCD_OpenWindow(uint16_t x, uint16_t y, uint16_t width, uint16_t height)
{	
	WriteComm(0X2A); 				 /* X */
	WriteData( x >> 8 );	 /* ȸ8λȻ8λ */
	WriteData( x & 0xff );	 /* ʼͽ*/
	WriteData( (x+width-1) >> 8 );
	WriteData( (x+width-1) & 0xff );

	WriteComm(0X2B); 			     /* Y*/
	WriteData( y >> 8 );
	WriteData( y & 0xff );
	WriteData( (y+height-1) >> 8);
	WriteData( (y+height-1) & 0xff);
}



void LCD_DispChar(uint16_t x, uint16_t y, uint8_t ascii, uint16_t color)
{
	uint16_t page, column, temp, i;
	i = ascii - ' ';
	
	LCD_OpenWindow(x, y, STR_WIDTH, STR_HEIGHT);
	WriteComm(0X2C);	
	
	for( page=0; page < STR_HEIGHT; page++ )
	{
		temp = asc2_1206[i][page];
		for( column=0; column < STR_WIDTH; column++ )
		{
			if( temp & 0x01 )
			{
				WriteData( color );
			}
			else
			{
				WriteData( WHITE);	//屳ɫ							
			}
			temp >>= 1;		
		}/* һд */
	}/* ȫд */
}
void LCD_DispStr(uint16_t x, uint16_t y, uint8_t *pstr, uint16_t color)
{  
	while( *pstr != '\0' )
	{
		if( x > (COLUMN-STR_WIDTH) )  //column240STR_WIDTH6
		{
			x = 0;
			y += STR_HEIGHT;
		}
		if( y > (PAGE-STR_HEIGHT) )
		{
			x = 0;
			y = 0;
		}
	//LCD_DispChar(x, y, ' ', color);
		LCD_DispChar(x, y, *pstr, color);
		x += STR_WIDTH;
		pstr++;
	}
}

//  temp = 345   length = 0
//  34           1
//  3            2
//  0            3


//  0    6    12
//  ____ ____ ____
void LCD_DisNum(uint16_t x, uint16_t y, uint32_t num, uint16_t color)
{
	uint32_t length = 0, temp = 0;
	temp = num;
	
	if( temp == 0 )
	{
		LCD_DispChar(x, y, '0', color);
		return;
	}
	
	while( temp )
	{
		temp /= 10;
		length ++;
	}
	
	while( num )
	{
		
		LCD_DispChar((x+STR_WIDTH*(length--)-STR_WIDTH), y, (num%10)+'0', color);
		num /= 10;
	}	
}
/* ҺGRAMɨ跽 
 * óɲͬɨģʽʱ, page(x)  column(y) ֵǻı
 */
void Lcd_GramScan( uint16_t option )
{	
	switch(option)
	{
		case 1:
		{/* Ͻ->½      ʾӢʱõģʽ */
			WriteComm(0x36); 
			WriteData(0xC8);   
			WriteComm(0X2A); 
		WriteData(0x00);	/* x start */	
			WriteData(0x00);
			WriteData(0x00);  /* x end */	
			WriteData(0xEF);

			WriteComm(0X2B); 
			WriteData(0x00);	/* y start */  
			WriteData(0x00);
			WriteData(0x01);	/* y end */   
			WriteData(0x3F);
					
		}break;
		case 2:
		{/* ½->Ͻ      ʾͷͼʱõģʽ */	
			WriteComm(0x36); 
		WriteData(0x68);	
			WriteComm(0X2A); 
			WriteData(0x00);
			WriteData(0x00);
			WriteData(0x01);
		  WriteData(0x3F);	

			WriteComm(0X2B); 
			WriteData(0x00);
			WriteData(0x00);
			WriteData(0x00);
			WriteData(0xEF);			
		}break;
		case 3:
		{/* ½->Ͻ      */
			WriteComm(0x36); 
			WriteData(0x28);	
			WriteComm(0X2A); 
			WriteData(0x00);
		WriteData(0x00);
			WriteData(0x01);
			WriteData(0x3F);	

		WriteComm(0X2B); 
			WriteData(0x00);
			WriteData(0x00);
			WriteData(0x00);
			WriteData(0xEF);			
		}break;
		case 4:
		{/* ½->Ͻ       */
			WriteComm(0x36); 
			WriteData(0x48);	
			WriteComm(0X2A); 
			WriteData(0x00);
				WriteData(0x00);
				WriteData(0x00);
				WriteData(0xEF);	

			WriteComm(0X2B); 
			WriteData(0x00);
				WriteData(0x00);
				WriteData(0x01);
			WriteData(0x3F);			
		}break;
	}
	
	/* write gram start */
	WriteComm(0x2C);
}
void DrawCross(uint16_t x,uint16_t y)//ʮ
{
   LCD_Clear(x, y, 20, 1, 1111);
   LCD_Clear(x+10, y-10, 1, 20, 1111);
}

void LCD_Number(u8 x,u16 y,u8 i,u16 tempcolor)
{ u8 temp,t,t1;
  u16 y0=y;
  Lcd_GramScan(4);
  for(t=0;t<36;t++)
  {	 temp=dhz[i][t];
     for(t1=0;t1<8;t1++)
	   { 
		   if(temp&0x80)  
			 {LCD_SetPoint( x, y, tempcolor);

       }
	     else
	     { 
			   // tempcolor=RED;
	   	    //POINT_COLOR=WHITE;
	   	   LCD_SetPoint( x, y, RED);
		     // POINT_COLOR= tempcolor;
	     }
	    temp<<=1;
	    y++;
	    if((y-y0)==24)
	     { 
				 y=y0;
	       x++;
	       break;
	     }
	  }
 }
}

//Ա
void LCD_DispNumber(uint16_t x, uint16_t y, uint32_t num, uint16_t color)
{
	uint32_t length = 0, temp = 0;
	temp = num;
//	 Lcd_GramScan(4);
	if( temp == 0 )
	{
		LCD_Number(x, y, 0, color);  //עҪҪð
		return;
	}
	
	while( temp )
	{// õnumĳ
		temp /= 10;
		length ++;
	}
	
	while( num )
	{
		/* Ӹλʼʾ */
		LCD_Number((x+STR_WIDTH*(length--)-STR_WIDTH), y, (num%10)+ 0, color);
		num /= 10;
	}	
}

/*------------------------------------------------------------------------------------------------------*/
/*    column 240
      _ _ _ _ _ _
 page|           |
     |           |
     |           |
     |           |
     |           |
     |           |  320        
     |           |
     |           |
     |           |
     |           |
     |           |
     |           |
      - - - - - -
*/

/* ʾһ 
 * СΪ 16ȣ* 16߶ȣ32ֽ
 * ȡģ˳Ϊλǰλں
 */
void LCD_DispCH(uint16_t x, uint16_t y, const uint8_t *pstr, uint16_t color)
{
	uint8_t page , column;
	uint8_t buffer[32];		
	uint16_t tmp_char=0;
	
	LCD_OpenWindow(x, y, CH_WIDTH, CH_HEIGHT);

	WriteComm(0X2C);
	
	GetGBKCode_from_sd(buffer,pstr);	 /* ȡģ */
	
	for(page=0; page< CH_HEIGHT; page++)
	{
    /* ȡֽڵݣlcdϼһֵһ */
		tmp_char=buffer[page*2];
		tmp_char=(tmp_char<<8);
		tmp_char|=buffer[2*page+1];
		
		for (column=0; column< CH_WIDTH; column++)
		{			
			if ( tmp_char & (0x01<<15) )  /* λǰ */
			{				
				WriteData(color);
			}
			else
			{			
				WriteData(WHITE);
			}
			tmp_char <<= 1;
		}
	}
}

/*
 * ʾһ
 */
void LCD_DispStrCH(uint16_t x, uint16_t y, const uint8_t *pstr, uint16_t color) 
{
	while( *pstr != '\0' )
	{
		if( x > (COLUMN-CH_WIDTH) )
		{
			x = 0;
			y += CH_HEIGHT;
		}
		if( y > (PAGE-CH_HEIGHT) )
		{
			x = 0;
			y = 0;
		}		
		LCD_DispCH(x, y, pstr, color);
		pstr +=2;   /* һֽ */  
		x += CH_WIDTH;		
	}	   
}

/* 
 * ӢĻʾʾı  
 * ĴС16*16
 * ӢĴС12*6
 */
void LCD_DispEnCh(uint16_t x, uint16_t y, const uint8_t *pstr, uint16_t color)
{
	while(*pstr != '\0')
	{
		if(*pstr <= 126)		/* ַ */
		{
			if( x > (COLUMN-STR_WIDTH) )
			{
				x = 0;
				y += STR_HEIGHT;
			}
			if( y > (PAGE-STR_HEIGHT) )
			{
				x = 0;
				y = 0;
			}
			LCD_DispChar(x, y, *pstr, color);
			x += STR_WIDTH;
			pstr++;
		}
		else	/*  */
		{
			if( x > (COLUMN-CH_WIDTH) )
			{
				x = 0;
				y += CH_HEIGHT;
			}
			if( y > (PAGE-CH_HEIGHT) )
			{
				x = 0;
				y = 0;
			}		
			LCD_DispCH(x, y, pstr, color);
			pstr +=2;
			x += CH_WIDTH;
    }
  }
} 
//	  
//(x1,y1),(x2,y2):εĶԽ
void LCD_DrawRectangle(u16 x1, u16 y1, u16 x2, u16 y2,u16 color)
{
	// color=BLACK;
//	LCD_Clear(x1,y1+1,x2,y1+1, BLACK); //xᣬ
//	LCD_Clear(x1+1,y1,x1+1,y2, BLACK);
//	LCD_Clear(x1,y2+1,x2,y2+1, BLACK);
//	LCD_Clear(x2+1,y1,x2+1,y2, BLACK);
	// LCD_DrawLine(u16 x1, u16 y1, u16 x2, u16 y2,u16 color)
	LCD_DrawLine(x1,y1,x2,y1,color);
	LCD_DrawLine(x1,y1,x1,y2, color);
	LCD_DrawLine(x1,y2,x2,y2,color);
	LCD_DrawLine(x2,y1,x2,y2,color);

}
/* -------------------------------------------end of file----------------------------------------------- */


